#!/usr/bin/env bash

## No bash script should be considered releasable until it has this! http://j.mp/safebash ##
# Exit if any statement returns a non-true return value (non-zero).
set -o errexit
# Exit on use of an uninitialized variable
set -o nounset
# produce debug info
#set -x  

#cd $(dirname $0)/../../..
echo "argument count provided is: " $# 
#[ "$#" -eq 0 ] || echo "1 or more argument required" $# "provided"

homedir=~
eval homedir=$homedir
echo "HOME DIR:" $homedir # prints home path

scriptdir="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
echo "SCRIPT DIR:" $scriptdir

appdir=$scriptdir"/../../MacOS"	

notesdir=$homedir"/Documents/Marking-Feedback-Assistant"
echo "NOTES DIR:" $notesdir
mkdir -p $notesdir

#copy the templates into the user Documents folder if they do not exist
#if [ ! -d "$notesdir"/Templates ]; then
#    echo "CREATING TEMPLATE DIR:" $notesdir/Templates
#    
#    mkdir -p $notesdir/Templates
#    cp -r ${appdir}/Templates $notesdir
#fi

#copy the default template of one doesnt exist
#if [ ! -f "$notesdir"/DefaultTemplate.jaj ]; then
#	echo "COPYING TEMPLATE:"
#	cp ${appdir}/Templates/DefaultTemplate.jaj $notesdir
#fi

echo "FILES ARE: "
	
# for each filename dropped
for file in "${@}"; do

	echo $file	

	filename="${file##*/}"                      # Strip longest match of */ from start
	dir="${file:0:${#file} - ${#filename}}" 	# Substring from 0 thru pos of filename
	base="${filename%.[^.]*}"                   # Strip shortest match of . plus at
												#   least one non-dot char from end
	ext="${filename:${#base} + 1}"              # Substring from len of base thru end
	if [[ -z "$base" && -n "$ext" ]]; then      # If we have an extension and no base, 			
												#   it's really the base
		base=".$ext"
		ext=""
	fi

   	echo -e "$file:\n\tdir  = \"$dir\"\n\tbase = \"$base\"\n\text  = \"$ext\""
   	
   	# set up the common java parameters required
   	JAVACMD=(-Dfile.encoding=UTF-8 -XX:CompileCommand=exclude,javax/swing/text/GlyphView,getBreakSpot -Xdock:icon=${appdir}/MFicon.png -Xdock:name="$base" -jar ${appdir}/marking.jar)
   	
   	if [ "$ext" == "xml" ]; then
   		echo "XML FILE" "\"$file\""
   		#tf= "\"$file\""
   		#echo "PDF FILE"$tf    
   		
   		# run the application in the background
   		#java "${JAVACMD[@]}" "$file" &
   		# the outputs are all directed to null to allow the calling applescript to finish
        # the rerun parameter is used to prevent the application from running itself again with the -XX parameter, since we have been able to add it in this script
        java "${JAVACMD[@]}" "$file" "rerun"> /dev/null 2>&1 &
   		 		 
		# java -Dfile.encoding=UTF-8 -Xdock:icon=${appdir}/jarnal.png -Xdock:name=Jarnal -Xmx192m -jar ${appdir}/jarnal.jar -b "$file" -s $dir$base"-"`eval date +%Y%m%d-%H%M`.jaj &
   	fi
   	
   	if [ "$ext" == "mfax" ]; then
   		echo "MFAX FILE" "$file"
   		
   		# run the application in the background 
   		# java "${JAVACMD[@]}" "$file" &
   		# the outputs are all directed to null to allow the calling applescript to finish
        # the rerun parameter is used to prevent the application from running itself again with the -XX parameter, since we have been able to add it in this script
   		java "${JAVACMD[@]}" "$file" "rerun"> /dev/null 2>&1 &
   		
		# java -Dfile.encoding=UTF-8 -Xmx192m -Xdock:icon=${appdir}/jarnal.png -Xdock:name=Jarnal -jar ${appdir}/jarnal.jar "$file" &
   	fi
		
done
